import { h, Component } from 'preact';
import Section from './section';
import ComponentCode from './component-code';
import { NumpadOverlay, NumpadButton } from '../numpad';
import { Button } from '../button';

class Container extends Component {
  constructor(props) {
    super(props);
    this.state = {
      value: 50,
      otherValue: 20,
      open: false
    };
  }

  render(props, { value, open, otherValue }) {
    return h(
      Section,
      { title: 'Numpads' },
      h(
        ComponentCode,
        {
          name: 'NumpadOverlay',
          code: `<NumpadOverlay
  unit="mg"
  max={200}
  maxDecimals={2}
  onValue={value => {
    this.setState({ value, open: false })
  }}
  onCancel={() => {
    this.setState({ open: false })
  }}
/>`
        },
        h(
          'span',
          { className: 'w4' },
          value,
          ' mg'
        ),
        h(
          Button,
          { onClick: () => this.setState({ open: true }) },
          'Update Value'
        ),
        open && h(NumpadOverlay, {
          unit: 'mg',
          max: 200,
          maxDecimals: 2,
          onValue: value => {
            this.setState({ value, open: false });
          },
          onCancel: () => {
            this.setState({ open: false });
          }
        })
      ),
      h(
        ComponentCode,
        {
          name: 'NumpadButton',
          code: `<NumpadButton
  unit="mg"
  max={500}
  maxDecimals={3}
  onValue={value => this.setState({ otherValue: value })}
/>`
        },
        h(
          'span',
          { className: 'w4 mr2' },
          otherValue,
          ' mg'
        ),
        h(NumpadButton, {
          unit: 'mg',
          max: 500,
          maxDecimals: 3,
          onValue: value => this.setState({ otherValue: value })
        })
      )
    );
  }
}

export default Container;