import ms from 'milliseconds';
import { readCookie, writeCookie, deleteCookie } from './cookie';
import { getLocalStorageItem, deleteLocalStorageItem } from './ls';

const NAME = 'token';

export const writeToken = token => {
  writeCookie(NAME, token, { maxAge: ms.days(180) });
};

export const readTokenValue = () => {
  const valueFromLS = getLocalStorageItem(NAME);
  const valueFromCookie = readCookie(NAME);
  if (valueFromLS && valueFromLS !== valueFromCookie) {
    writeToken(valueFromLS);
    deleteLocalStorageItem(NAME);
  }
  return valueFromCookie;
};

export const clearToken = () => deleteCookie(NAME);